﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Input;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using C1.WPF;

namespace DataGridSample
{
    public class DataGridViewModel :ViewModelBase
    {
        ObservableCollection<Category> categories;
        ObservableCollection<Product> products;
        ObservableCollection<Product> Allproducts;
        Category _selected = null;

        public DataGridViewModel()
        {
            Categories = new ObservableCollection<Category>();
            Categories.Add(new Category { Name = "AA", Id = 1 });
            Categories.Add(new Category { Name = "BB", Id = 2 });
            Categories.Add(new Category { Name = "CC", Id = 3});
            Categories.Add(new Category { Name = "DD", Id = 4 });
            Categories.Add(new Category { Name = "EE", Id = 5});
            Categories.Add(new Category { Name = "FF", Id = 6 });
            Categories.Add(new Category { Name = "GG", Id = 7});
            Categories.Add(new Category { Name = "HH", Id = 8});
            Categories.Add(new Category { Name = "II", Id = 9 });
            Categories.Add(new Category { Name = "JJ", Id = 10 });
            Categories.Add(new Category { Name = "AA", Id = 11 });
            Categories.Add(new Category { Name = "BB", Id = 12 });
            Categories.Add(new Category { Name = "CC", Id = 13 });
            Categories.Add(new Category { Name = "DD", Id = 14 });
            Categories.Add(new Category { Name = "EE", Id = 15 });
            Categories.Add(new Category { Name = "FF", Id = 16 });
            Categories.Add(new Category { Name = "GG", Id = 17 });
            Categories.Add(new Category { Name = "HH", Id = 18 });
            Categories.Add(new Category { Name = "II", Id = 19 });
            Categories.Add(new Category { Name = "JJ", Id = 20 });
            Categories.Add(new Category { Name = "AA", Id = 21 });
            Categories.Add(new Category { Name = "BB", Id = 22 });
            Categories.Add(new Category { Name = "CC", Id = 23 });
            Categories.Add(new Category { Name = "DD", Id =24 });
            Categories.Add(new Category { Name = "EE", Id = 25 });
            Categories.Add(new Category { Name = "FF", Id = 26 });
            Categories.Add(new Category { Name = "GG", Id = 27 });
            Categories.Add(new Category { Name = "HH", Id = 28 });
            Categories.Add(new Category { Name = "II", Id = 29 });
            Categories.Add(new Category { Name = "JJ", Id = 30 });
            Allproducts = new ObservableCollection<Product>();
            Allproducts.Add(new Product { Name = "AA", Id = 1,CategoryId=1 });
            Allproducts.Add(new Product { Name = "BB", Id = 2, CategoryId = 1 });
            Allproducts.Add(new Product { Name = "CC", Id = 3, CategoryId = 1 });
            Allproducts.Add(new Product { Name = "DD", Id = 4, CategoryId = 3 });
            Allproducts.Add(new Product { Name = "EE", Id = 5, CategoryId = 8 });
            Allproducts.Add(new Product { Name = "FF", Id = 6, CategoryId = 9 });
            Allproducts.Add(new Product { Name = "GG", Id = 7, CategoryId = 1 });
            Allproducts.Add(new Product { Name = "HH", Id = 8, CategoryId = 10 });
            Allproducts.Add(new Product { Name = "II", Id = 9, CategoryId = 1 });
            Allproducts.Add(new Product { Name = "JJ", Id = 10, CategoryId =5 });
            Allproducts.Add(new Product { Name = "AA", Id = 11, CategoryId = 1 });
            Allproducts.Add(new Product { Name = "BB", Id = 12, CategoryId = 15 });
            Allproducts.Add(new Product { Name = "CC", Id = 13, CategoryId = 7 });
            Allproducts.Add(new Product { Name = "DD", Id = 14, CategoryId = 3 });
            Allproducts.Add(new Product { Name = "EE", Id = 15, CategoryId = 12 });
            Allproducts.Add(new Product { Name = "FF", Id = 16, CategoryId = 2 });
            Allproducts.Add(new Product { Name = "GG", Id = 17, CategoryId = 4 });
            Allproducts.Add(new Product { Name = "HH", Id = 18, CategoryId = 27 });
            Allproducts.Add(new Product { Name = "II", Id = 19, CategoryId = 1 });
            Allproducts.Add(new Product { Name = "JJ", Id = 20, CategoryId = 5 });
            Allproducts.Add(new Product { Name = "AA", Id = 21, CategoryId = 21 });
            Allproducts.Add(new Product { Name = "BB", Id = 22, CategoryId = 21 });
            Allproducts.Add(new Product { Name = "CC", Id = 23, CategoryId = 1 });
            Allproducts.Add(new Product { Name = "DD", Id = 24, CategoryId = 3 });
            Allproducts.Add(new Product { Name = "EE", Id = 25, CategoryId = 4 });
            Allproducts.Add(new Product { Name = "FF", Id = 26, CategoryId = 2 });
            Allproducts.Add(new Product { Name = "GG", Id = 27, CategoryId = 6 });
            Allproducts.Add(new Product { Name = "HH", Id = 28, CategoryId = 7 });
            Allproducts.Add(new Product { Name = "II", Id = 29, CategoryId = 1 });
            Allproducts.Add(new Product { Name = "JJ", Id = 30, CategoryId = 15 });
            Allproducts.Add(new Product { Name = "AA", Id = 111, CategoryId = 7 });
            Allproducts.Add(new Product { Name = "BB", Id = 112, CategoryId = 15 });
            Allproducts.Add(new Product { Name = "CC", Id = 113, CategoryId = 1 });
            Allproducts.Add(new Product { Name = "DD", Id = 114, CategoryId = 13 });
            Allproducts.Add(new Product { Name = "EE", Id = 115, CategoryId = 12 });
            Allproducts.Add(new Product { Name = "FF", Id = 116, CategoryId = 12 });
            Allproducts.Add(new Product { Name = "GG", Id = 117, CategoryId = 11 });
            Allproducts.Add(new Product { Name = "HH", Id = 118, CategoryId = 17 });
            Allproducts.Add(new Product { Name = "II", Id = 119, CategoryId = 11 });
            Allproducts.Add(new Product { Name = "JJ", Id = 120, CategoryId = 25 });

            this.SelectedCategory = categories[0];

            Products = new ObservableCollection<Product>();
        }

        public ObservableCollection<Category> Categories
        {
            get
            {
                return categories;
            }
            set
            {
                categories = value;
                OnPropertyChanged("Categories");
            }
        }
        public ObservableCollection<Product> Products
        {
            get
            {
                return products;
            }
            set
            {
                products = value;
                OnPropertyChanged("Products");
            }
        }

        public Category SelectedCategory
        {
            get { return _selected; }
            set
            {
                if (_selected != value )
                {
                    _selected = value;
                    if (_selected!= null)
                    {
                        this.Products = new ObservableCollection<Product>(this.Allproducts.Where(t => t.CategoryId == this._selected.Id).ToList());
                    }
                    
                    OnPropertyChanged("SelectedCategory");
                }
            }
        }

    }
}
